#include <time.h>

//0x82608EDB // The IEEE 802.3 standard: HD=6 for 172-268; HD=8 for 58-91
//0x8F6E37A0 // Castagnoli (iSCSI): HD=6 for 178-5243; HD=8 for 48-177
//0xBA0DC66B // Koopman: HD=6 for 153-16360; HD=8 for 19-152
//0x90022004 // Koopman: HD=6!!! for 8!!!-32738

//CRC-32 HDLC, ANSI X3.66, ITU-T V.42, Ethernet, Serial ATA, MPEG-2, PKZIP, Gzip, Bzip2, PNG,[24] many others) 	0x04C11DB7 / 0xEDB88320 / 0x82608EDB[10]
//CRC-32C (Castagnoli) iSCSI, SCTP, G.hn payload, SSE4.2, Btrfs, ext4						1EDC6F41 / 0x82F63B78 / 0x8F6E37A0[10]
//CRC-32K (Koopman)												741B8CD7 / 0xEB31D82E / 0xBA0DC66B[10]

/*
E:\Knight-tour_r8dump_Yorikke_CRC8>cl /Ox Knight-tour_r8dump_Yorikke_CRC8.c
Microsoft (R) 32-bit C/C++ Optimizing Compiler Version 16.00.30319.01 for 80x86
Copyright (C) Microsoft Corporation.  All rights reserved.

Knight-tour_r8dump_Yorikke_CRC8.c
Microsoft (R) Incremental Linker Version 10.00.30319.01
Copyright (C) Microsoft Corporation.  All rights reserved.

/out:Knight-tour_r8dump_Yorikke_CRC8.exe
Knight-tour_r8dump_Yorikke_CRC8.obj

E:\Knight-tour_r8dump_Yorikke_CRC8>Knight-tour_r8dump_Yorikke_CRC8.exe a8 10000000
Knight-tour_r8dump_Yorikke, subrevision B, written by Kaze (based on Kurt White's code), downloadable at www.sanmayce.com/Fastest_Hash
Purpose: to compare FNV1A_Yorikke and CRC32 by giving the highest number of collisions i.e. the deepest nest/layer, the-lesser-the-better.
Polynomial used:
#define CRCPOLY 0xEDB88320 // CRC32
#define CRCPOLYC 0x82F63B78 // CRC32C
#define CRCINIT 0xFFFFFFFF
KT to be hashed = 00,010,000,000
HashSizeInBits = 7
ReportAtEvery = 1,000,000
Allocating HASH memory 0MB ... OK
Allocating HASH memory 0MB ... OK
Allocating HASH memory 0MB ... OK
FNV1A_Yorikke: KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,052; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,051; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,001,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 008,026; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,966; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,897; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,002,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 015,938; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,893; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,730; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,003,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 023,720; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,632; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,652; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,004,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 031,661; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,520; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,395; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,005,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 039,617; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,476; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,406; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,006,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 047,389; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,399; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,169; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,007,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 055,204; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,205; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,166; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,008,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 063,063; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,992; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,937; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,009,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 070,829; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
FNV1A_Yorikke: KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,922; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32_4slice : KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,942; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%
CRC32C_8slice: KT_DumpCounter = 00,010,000,000; 000,000,001 x MAXcollisionsAtSomeSlots = 078,631; HASHfreeSLOTS = 0,000,000,000; HashUtilization = 100%

E:\Knight-tour_r8dump_Yorikke_CRC8>
*/

#include <windows.h>

#include <stdint.h> // uint8_t needed
//typedef unsigned char uint8_t;
//typedef unsigned short uint16_t;
//typedef unsigned int uint32_t;

#define _rotl_KAZE(x, n) (((x) << (n)) | ((x) >> (32-(n))))
#define HashSizeInBits 26 //256MB
#define ReportAtEvery (1<<HashSizeInBits)-1 //1000000

int PrintTheFirstKTvariants=0;

// "There it now stands for ever. Black on white.
// I can't get away from it. Ahoy, Yorikke, ahoy, hoy, ho!
// Go to hell now if you wish. What do I care? It's all the same now to me.
// I am part of you now. Where you go I go, where you leave I leave, when you go to the devil I go. Married.
// Vanished from the living. Damned and doomed. Of me there is not left a breath in all the vast world.
// Ahoy, Yorikke! Ahoy, hoy, ho!
// I am not buried in the sea,
// The death ship is now part of me
// So far from sunny New Orleans
// So far from lovely Louisiana."
// /An excerpt from 'THE DEATH SHIP - THE STORY OF AN AMERICAN SAILOR' by B.TRAVEN/
// 
// "Walking home to our good old Yorikke, I could not help thinking of this beautiful ship, with a crew on board that had faces as if they were seeing ghosts by day and by night.
// Compared to that gilded Empress, the Yorikke was an honorable old lady with lavender sachets in her drawers.
// Yorikke did not pretend to anything she was not. She lived up to her looks. Honest to her lowest ribs and to the leaks in her bilge.
// Now, what is this? I find myself falling in love with that old jane.
// All right, I cannot pass by you, Yorikke; I have to tell you I love you. Honest, baby, I love you.
// I have six black finger-nails, and four black and green-blue nails on my toes, which you, honey, gave me when necking you.
// Grate-bars have crushed some of my toes. And each finger-nail has its own painful story to tell.
// My chest, my back, my arms, my legs are covered with scars of burns and scorchings.
// Each scar, when it was being created, caused me pains which I shall surely never forget.
// But every outcry of pain was a love-cry for you, honey.
// You are no hypocrite. Your heart does not bleed tears when you do not feel heart-aches deeply and truly.
// You do not dance on the water if you do not feel like being jolly and kicking chasers in the pants.
// Your heart never lies. It is fine and clean like polished gold. Never mind the rags, honey dear.
// When you laugh, your whole soul and all your body is laughing.
// And when you weep, sweety, then you weep so that even the reefs you pass feel like weeping with you.
// I never want to leave you again, honey. I mean it. Not for all the rich and elegant buckets in the world.
// I love you, my gypsy of the sea!"
// /An excerpt from 'THE DEATH SHIP - THE STORY OF AN AMERICAN SAILOR' by B.TRAVEN/
uint32_t FNV1A_Hash_Yorikke(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    const char *p = str;

    for(; wrdlen >= 2*2*sizeof(uint32_t); wrdlen -= 2*2*sizeof(uint32_t), p += 2*2*sizeof(uint32_t)) {
        hash32 = (hash32 ^ (_rotl_KAZE(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
        hash32B = (hash32B ^ (_rotl_KAZE(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
    }

    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;

    hash32 = (hash32 ^ _rotl_KAZE(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}


uint32_t FNV1A_Hash_Yoshimitsu(const char *str, uint32_t wrdlen)
{
    const uint32_t PRIME = 709607;
    uint32_t hash32 = 2166136261;
    uint32_t hash32B = 2166136261;
    uint32_t hash32C = 2166136261;
    uint32_t hash32D = 2166136261;
    const char *p = str;

    for(; wrdlen >= 4*2*sizeof(uint32_t); wrdlen -= 4*2*sizeof(uint32_t), p += 4*2*sizeof(uint32_t)) {
        //hash32 = (hash32 ^ (_rotl_KAZE(*(DWORD *)(p+0),5) ^ *(DWORD *)(p+4))) * PRIME;        
        //hash32B = (hash32B ^ (_rotl_KAZE(*(DWORD *)(p+8),5) ^ *(DWORD *)(p+12))) * PRIME;        
//        hash32 = _rotl_KAZE( (hash32 ^ (_rotl_KAZE(*(DWORD *)(p+0),5) ^ *(DWORD *)(p+4))) , 19); // 1<<19 = 524288 ~ 709607; * -> <<'s
//        hash32B = _rotl_KAZE( (hash32B ^ (_rotl_KAZE(*(DWORD *)(p+8),5) ^ *(DWORD *)(p+12))) , 19); 
/*
$LL7@FNV1A_Hash@2:
; Line 159
	mov	ebx, DWORD PTR [eax]
	rol	ebx, 5
	xor	ebx, DWORD PTR [eax+4]
	sub	edx, 16
	xor	esi, ebx
; Line 160
	mov	ebx, DWORD PTR [eax+8]
	ror	esi, 13
	rol	ebx, 5
	xor	ebx, DWORD PTR [eax+12]
	add	eax, 16
	xor	ecx, ebx
	ror	ecx, 13
	dec	edi
	jne	SHORT $LL7@FNV1A_Hash@2
*/

		//3*2*sizeof(DWORD)
		//hash32 = ( (hash32 ^ (_rotl(*(DWORD *)(p+0),5) ^ *(DWORD *)(p+4))) * PRIME ) ^ ( *(DWORD *)(p+8) * PRIME );
		//hash32B = ( (hash32B ^ (_rotl(*(DWORD *)(p+12),5) ^ *(DWORD *)(p+16))) * PRIME ) ^ ( *(DWORD *)(p+20) * PRIME );

		//4*2*sizeof(DWORD)
		hash32 = (hash32 ^ (_rotl(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		hash32C = (hash32C ^ (_rotl(*(uint32_t *)(p+16),5) ^ *(uint32_t *)(p+20))) * PRIME;        
		hash32D = (hash32D ^ (_rotl(*(uint32_t *)(p+24),5) ^ *(uint32_t *)(p+28))) * PRIME;        
// 442-3f5+2= 79 bytes, CARAMBA: there is no free register to house the counter: 'dec DWORD PTR tv170[esp+12]' instead of 'dec edi' as in "ROL 13" lines below.
/*
$LL9@Hash_Yoshi:
; 1498 : 		hash32 = (hash32 ^ (_rotl(*(DWORD *)(p+0),5) ^ *(DWORD *)(p+4))) * PRIME;        

  003f5	8b 18		 mov	 ebx, DWORD PTR [eax]
  003f7	c1 c3 05	 rol	 ebx, 5
  003fa	33 58 04	 xor	 ebx, DWORD PTR [eax+4]
  003fd	83 ea 20	 sub	 edx, 32			; 00000020H
  00400	33 f3		 xor	 esi, ebx

; 1499 : 		hash32B = (hash32B ^ (_rotl(*(DWORD *)(p+8),5) ^ *(DWORD *)(p+12))) * PRIME;        

  00402	8b 58 08	 mov	 ebx, DWORD PTR [eax+8]
  00405	69 f6 e7 d3 0a
	00		 imul	 esi, 709607		; 000ad3e7H
  0040b	c1 c3 05	 rol	 ebx, 5
  0040e	33 58 0c	 xor	 ebx, DWORD PTR [eax+12]
  00411	83 c0 20	 add	 eax, 32			; 00000020H
  00414	33 cb		 xor	 ecx, ebx

; 1500 : 		hash32C = (hash32C ^ (_rotl(*(DWORD *)(p+16),5) ^ *(DWORD *)(p+20))) * PRIME;        

  00416	8b 58 f0	 mov	 ebx, DWORD PTR [eax-16]
  00419	69 c9 e7 d3 0a
	00		 imul	 ecx, 709607		; 000ad3e7H
  0041f	c1 c3 05	 rol	 ebx, 5
  00422	33 58 f4	 xor	 ebx, DWORD PTR [eax-12]
  00425	33 fb		 xor	 edi, ebx

; 1501 : 		hash32D = (hash32D ^ (_rotl(*(DWORD *)(p+24),5) ^ *(DWORD *)(p+28))) * PRIME;        

  00427	8b 58 f8	 mov	 ebx, DWORD PTR [eax-8]
  0042a	69 ff e7 d3 0a
	00		 imul	 edi, 709607		; 000ad3e7H
  00430	c1 c3 05	 rol	 ebx, 5
  00433	33 58 fc	 xor	 ebx, DWORD PTR [eax-4]
  00436	33 eb		 xor	 ebp, ebx
  00438	69 ed e7 d3 0a
	00		 imul	 ebp, 709607		; 000ad3e7H
  0043e	ff 4c 24 18	 dec	 DWORD PTR tv170[esp+12]
  00442	75 b1		 jne	 SHORT $LL9@Hash_Yoshi
*/
/*
E:\_KAZE_hash_Yoshimitsu>hash KT5million.txt
5000000 lines read
16777216 elements in the table (24 bits)
           Jesteress:    5927892   5892203   5891877   5885865   5895333   5892451   5886949   5891559   5895370   5888990|   5885865 [676877]
              Meiyan:    5850738   5855457   5847735   5849722   5847868   5845189   5850087   5846843   5847820   5845907|   5845189 [676877]
             Yorikke:    5680415   5679205   5684177   5680280   5686396   5680565   5681035   5679829   5682245   5681052|   5679205 [677478]
          Yoshimitsu:    5680400   5680252   5684833   5688414   5680524   5678596   5677554   5678393   5680015   5680396|   5677554 [675312]
        x17 unrolled: ^C
E:\_KAZE_hash_Yoshimitsu>hash KTR5million.txt
5000000 lines read
16777216 elements in the table (24 bits)
           Jesteress:    5772704   5742091   5736934   5738746   5742657   5741104   5741102   5737908   5738002   5742116|   5736934 [676000]
              Meiyan:    5700057   5695889   5700702   5694799   5699576   5697662   5693863   5697606   5696133   5695485|   5693863 [676000]
             Yorikke:    5523796   5527643   5528195   5530897   5523567   5526035   5521989   5527258   5531218   5524544|   5521989 [676570]
          Yoshimitsu:    5520833   5521105   5518502   5517657   5519659   5520483   5517938   5521405   5519923   5518780|   5517657 [676009]
        x17 unrolled: ^C
E:\_KAZE_hash_Yoshimitsu>hash "Word-list_12,561,874_wikipedia-en-html.tar.wrd"
12561874 lines read
33554432 elements in the table (25 bits)
           Jesteress:   10749318  10649149  10646657  10635909  10657954  10645701  10656154  10656770  10672870  10637745|  10635909 [2121868]
              Meiyan:   10632817  10635278  10610784  10636058  10615126  10637501  10633724  10638480  10633424  10632864|  10610784 [2111271]
             Yorikke:   10656032  10672142  10673068  10673462  10671225  10673482  10670054  10672436  10677540  10670661|  10656032 [2084954]
          Yoshimitsu:   10828843  10846370  10843574  10808386  10809707  10807612  10810108  10794792  10808601  10808285|  10794792 [2084954]
        x17 unrolled: ^C
E:\_KAZE_hash_Yoshimitsu>hash 100MB_as_one_line.TXT
1 lines read
4 elements in the table (2 bits)
           Jesteress:     204418    204277    204025    203698    203971    204613    204024    204038    204817    203649    203986    204830    20
3903    204275    203998    203979    206157    203964    204222    204992    203941    204735    203936    203846    204139    204006    204257
204852    204054    204637    204754    203782    204939    203756    204229    203863    203781    204314    203805    204040|    203649 [    0]
              Meiyan:     207161    203931    204162    204427    204259    204067    204779    203789    204676    204227    204166    204609    20
3947    204061    204948    204129    205497    203990    204197    204580    204167    204019    207285    203850    204626    204024    204115
203722    204069    203956    204686    203754    204179    204763    204100    204783    204213    205179    203876    203880|    203722 [    0]
             Yorikke:     182415    182293    181865    182346    185258    181676    182305    181862    182163    181989    181598    181416    18
2537    182109    181896    181729    182853    181463    183008    181789    181859    182113    182420    181404    182609    182124    181972
181936    184815    181467    182594    182138    182085    181910    181963    181442    182487    183794    181833    182204|    181404 [    0]
          Yoshimitsu:     180939    179829    181113    180314    180039    180551    179739    180056    180797    180264    180280    180123    18
3607    180034    180784    180136    180662    180274    180357    180014    180351    180705    180533    180294    180898    180164    180208
180767    179852    180580    180098    180465    180397    180738    180057    180502    216061    180029    180124    180669|    179739 [    0]
        x17 unrolled:     957197^C
E:\_KAZE_hash_Yoshimitsu>
*/

		//hash32 = ( ( ( (hash32 ^ (_rotl(*(DWORD *)(p+0),5) ^ *(DWORD *)(p+4))) * ((1<<13)-1)) ^ (_rotl(*(DWORD *)(p+8),5)^*(DWORD *)(p+12)) ) * ((1<<13)-1));
		//hash32B = ( ( ( (hash32B ^ (_rotl(*(DWORD *)(p+16),5) ^ *(DWORD *)(p+20))) * ((1<<13)-1)) ^ (_rotl(*(DWORD *)(p+24),5) ^ *(DWORD *)(p+28)) ) * ((1<<13)-1)); // ((1<<13)-1)=8191 prime

		//hash32 = _rotl( ( _rotl( (hash32 ^ (_rotl(*(DWORD *)(p+0),5) ^ *(DWORD *)(p+4))) , 13) ^ (_rotl(*(DWORD *)(p+8),5)^*(DWORD *)(p+12)) ) , 13);
		//hash32B = _rotl( ( _rotl( (hash32B ^ (_rotl(*(DWORD *)(p+16),5) ^ *(DWORD *)(p+20))) , 13) ^ (_rotl(*(DWORD *)(p+24),5) ^ *(DWORD *)(p+28)) ) , 13);
// !!! 62e-5f0+2= 64 bytes !!!
/*
$LL8@Hash_Yoshi:
; 1384 : 		hash32 = _rotl( ( _rotl( (hash32 ^ (_rotl(*(DWORD *)(p+0),5) ^ *(DWORD *)(p+4))) , 13) ^ (_rotl(*(DWORD *)(p+8),5)^*(DWORD *)(p+12)) ) , 13);

  005f0	8b 18		 mov	 ebx, DWORD PTR [eax]
  005f2	c1 c3 05	 rol	 ebx, 5
  005f5	33 58 04	 xor	 ebx, DWORD PTR [eax+4]
  005f8	83 ea 20	 sub	 edx, 32			; 00000020H
  005fb	33 de		 xor	 ebx, esi
  005fd	8b 70 08	 mov	 esi, DWORD PTR [eax+8]
  00600	c1 c3 0d	 rol	 ebx, 13			; 0000000dH
  00603	c1 c6 05	 rol	 esi, 5
  00606	33 f3		 xor	 esi, ebx
  00608	33 70 0c	 xor	 esi, DWORD PTR [eax+12]

; 1385 : 		hash32B = _rotl( ( _rotl( (hash32B ^ (_rotl(*(DWORD *)(p+16),5) ^ *(DWORD *)(p+20))) , 13) ^ (_rotl(*(DWORD *)(p+24),5) ^ *(DWORD *)(p+28)) ) , 13);

  0060b	8b 58 10	 mov	 ebx, DWORD PTR [eax+16]
  0060e	c1 c6 0d	 rol	 esi, 13			; 0000000dH
  00611	c1 c3 05	 rol	 ebx, 5
  00614	33 58 14	 xor	 ebx, DWORD PTR [eax+20]
  00617	83 c0 20	 add	 eax, 32			; 00000020H
  0061a	33 d9		 xor	 ebx, ecx
  0061c	8b 48 f8	 mov	 ecx, DWORD PTR [eax-8]
  0061f	c1 c3 0d	 rol	 ebx, 13			; 0000000dH
  00622	c1 c1 05	 rol	 ecx, 5
  00625	33 cb		 xor	 ecx, ebx
  00627	33 48 fc	 xor	 ecx, DWORD PTR [eax-4]
  0062a	c1 c1 0d	 rol	 ecx, 13			; 0000000dH
  0062d	4f		 dec	 edi
  0062e	75 c0		 jne	 SHORT $LL8@Hash_Yoshi
  00630	5b		 pop	 ebx
$LN6@Hash_Yoshi:
*/

    }
	if (p != str) {
		hash32 = (hash32 ^ _rotl(hash32C,5) ) * PRIME;
		hash32B = (hash32B ^ _rotl(hash32D,5) ) * PRIME;
	}

    // 1111=15; 10111=23
    if (wrdlen & 4*sizeof(uint32_t)) {	
		hash32 = (hash32 ^ (_rotl(*(uint32_t *)(p+0),5) ^ *(uint32_t *)(p+4))) * PRIME;        
		hash32B = (hash32B ^ (_rotl(*(uint32_t *)(p+8),5) ^ *(uint32_t *)(p+12))) * PRIME;        
		p += 8*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7,...,15
    if (wrdlen & 2*sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint32_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint32_t*)(p+4)) * PRIME;
		p += 4*sizeof(uint16_t);
    }
    // Cases: 0,1,2,3,4,5,6,7
    if (wrdlen & sizeof(uint32_t)) {
		hash32 = (hash32 ^ *(uint16_t*)(p+0)) * PRIME;
		hash32B = (hash32B ^ *(uint16_t*)(p+2)) * PRIME;
		p += 2*sizeof(uint16_t);
    }
    if (wrdlen & sizeof(uint16_t)) {
        hash32 = (hash32 ^ *(uint16_t*)p) * PRIME;
        p += sizeof(uint16_t);
    }
    if (wrdlen & 1) 
        hash32 = (hash32 ^ *p) * PRIME;

    hash32 = (hash32 ^ _rotl(hash32B,5) ) * PRIME;
    return hash32 ^ (hash32 >> 16);
}

// CRC_SlicingBy8

#define CRCPOLYK1 0xBA0DC66B //CRC-32K_0xBA0DC66B
#define CRCPOLYK2 0x90022004 //CRC-32K_0x90022004

#define CRCPOLYC1 0x82F63B78 //CRC-32C_0x82F63B78
#define CRCPOLYC2 0x8F6E37A0 //CRC-32C_0x8F6E37A0

//(0x82F63B78 vs 0xEDB88320)
#define CRCPOLYC 0x82F63B78
#define CRCPOLY 0xEDB88320
#define CRCINIT 0xFFFFFFFF
 
uint32_t g_crc_slicingK1[8][256];
uint32_t g_crc_slicingK2[8][256];
uint32_t g_crc_slicingC1[8][256];
uint32_t g_crc_slicingC2[8][256];
uint32_t g_crc_precalc[4][256]; // CRC-32

static uint32_t Min(uint32_t x, uint32_t y) {
    // Branchless minimum (from http://graphics.stanford.edu/~seander/bithacks.html#IntegerMinOrMax)
    //return y ^ ((x ^ y) & -(x < y));
     return (x < y) ? x : y; // CMOV is used when /arch:SSE2 is on
}

static void CRC_SlicingInitK1() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYK1 & (-(int)(x & 1)));
		g_crc_slicingK1[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingK1[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingK1[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingK1[j][i] = c;
		}
	}
}

static void CRC_SlicingInitK2() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYK2 & (-(int)(x & 1)));
		g_crc_slicingK2[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingK2[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingK2[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingK2[j][i] = c;
		}
	}
}

static void CRC_SlicingInitC1() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYC1 & (-(int)(x & 1)));
		g_crc_slicingC1[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingC1[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingC1[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingC1[j][i] = c;
		}
	}
}

static void CRC_SlicingInitC2() {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for (i = 0; i <= 0xFF; i++) {
		x = i;
		for (j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLYC2 & (-(int)(x & 1)));
		g_crc_slicingC2[0][i] = x;
	}
 
	for (i = 0; i <= 0xFF; i++) {
		c = g_crc_slicingC2[0][i];
		for (j = 1; j < 8; j++) {
			c = g_crc_slicingC2[0][c & 0xFF] ^ (c >> 8);
			g_crc_slicingC2[j][i] = c;
		}
	}
}


uint32_t CRC_SlicingBy8K1(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingK1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingK1[7][(crc      ) & 0xFF] ^
			g_crc_slicingK1[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingK1[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingK1[4][(crc >> 24)] ^
			g_crc_slicingK1[3][(next      ) & 0xFF] ^
			g_crc_slicingK1[2][(next >>  8) & 0xFF] ^
			g_crc_slicingK1[1][(next >> 16) & 0xFF] ^
			g_crc_slicingK1[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingK1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8K2(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingK2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingK2[7][(crc      ) & 0xFF] ^
			g_crc_slicingK2[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingK2[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingK2[4][(crc >> 24)] ^
			g_crc_slicingK2[3][(next      ) & 0xFF] ^
			g_crc_slicingK2[2][(next >>  8) & 0xFF] ^
			g_crc_slicingK2[1][(next >> 16) & 0xFF] ^
			g_crc_slicingK2[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingK2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8C1(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingC1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingC1[7][(crc      ) & 0xFF] ^
			g_crc_slicingC1[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingC1[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingC1[4][(crc >> 24)] ^
			g_crc_slicingC1[3][(next      ) & 0xFF] ^
			g_crc_slicingC1[2][(next >>  8) & 0xFF] ^
			g_crc_slicingC1[1][(next >> 16) & 0xFF] ^
			g_crc_slicingC1[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingC1[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}

uint32_t CRC_SlicingBy8C2(const char* buf, uint32_t len) {
	uint32_t crc = CRCINIT;

uint32_t nqwords;
uint32_t next;
 
	// Align to DWORD boundary
	uint32_t align = (sizeof(uint32_t) - (INT_PTR)buf) & (sizeof(uint32_t) - 1); // needs windows.h
	
	align = Min(align, len);
	len -= align;
	for (; align; align--)
		crc = g_crc_slicingC2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
 
	nqwords = len / (sizeof(uint32_t) + sizeof(uint32_t));
	for (; nqwords; nqwords--) {
		crc ^= *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		next = *(uint32_t*)buf;
		buf += sizeof(uint32_t);
		crc =
			g_crc_slicingC2[7][(crc      ) & 0xFF] ^
			g_crc_slicingC2[6][(crc >>  8) & 0xFF] ^
			g_crc_slicingC2[5][(crc >> 16) & 0xFF] ^
			g_crc_slicingC2[4][(crc >> 24)] ^
			g_crc_slicingC2[3][(next      ) & 0xFF] ^
			g_crc_slicingC2[2][(next >>  8) & 0xFF] ^
			g_crc_slicingC2[1][(next >> 16) & 0xFF] ^
			g_crc_slicingC2[0][(next >> 24)];
	}
 
	len &= sizeof(uint32_t) * 2 - 1;
	for (; len; len--)
		crc = g_crc_slicingC2[0][(crc ^ *buf++) & 0xFF] ^ (crc >> 8);
	return ~crc;
}


// CRC-32
//#define CRCPOLY 0xEDB88320
//#define CRCINIT 0xFFFFFFFF

void CRC32Init(void) {
uint32_t i;
uint32_t x;
uint32_t j;
uint32_t c;
	for(i = 0; i <= 0xFF; i++) {
		x = i;
		for(j = 0; j < 8; j++)
			x = (x>>1) ^ (CRCPOLY & (-(int)(x & 1)));
		g_crc_precalc[0][i] = x;
	}

	for(i = 0; i <= 0xFF; i++) {
		c = g_crc_precalc[0][i];
		for(j = 1; j < 4; j++) {
			c = g_crc_precalc[0][c & 0xFF] ^ (c >> 8);
			g_crc_precalc[j][i] = c;
		}
	}
}

uint32_t CRC32(const char* key, uint32_t len) {
	uint32_t crc = CRCINIT;
	uint32_t ndwords = len / sizeof(uint32_t);
uint32_t c;
	for(; ndwords; ndwords--) {
		crc ^= *(uint32_t*)key;
		crc =
			g_crc_precalc[3][(crc      ) & 0xFF] ^
			g_crc_precalc[2][(crc >>  8) & 0xFF] ^
			g_crc_precalc[1][(crc >> 16) & 0xFF] ^
			g_crc_precalc[0][(crc >> 24) & 0xFF];
		key += sizeof(uint32_t);
	}
	if (len & sizeof(uint16_t)) {
		c = crc ^ *(uint16_t*)key;
		crc = g_crc_precalc[1][(c     ) & 0xFF] ^
			  g_crc_precalc[0][(c >> 8) & 0xFF] ^ (crc >> 16);
		key += sizeof(uint16_t);
	}
	//if (len & sizeof(BYTE))
	if (len & 1)
		crc = g_crc_precalc[0][(crc ^ *key) & 0xFF] ^ (crc >> 8);
	return ~crc;
}


void x64toaKAZE (      /* stdcall is faster and smaller... Might as well use it for the helper. */
        unsigned long long val,
        char *buf,
        unsigned radix,
        int is_neg
        )
{
        char *p;                /* pointer to traverse string */
        char *firstdig;         /* pointer to first digit */
        char temp;              /* temp char */
        unsigned digval;        /* value of digit */

        p = buf;

        if ( is_neg )
        {
            *p++ = '-';         /* negative, so output '-' and negate */
            val = (unsigned long long)(-(long long)val);
        }

        firstdig = p;           /* save pointer to first digit */

        do {
            digval = (unsigned) (val % radix);
            val /= radix;       /* get next digit */

            /* convert to ascii and store */
            if (digval > 9)
                *p++ = (char) (digval - 10 + 'a');  /* a letter */
            else
                *p++ = (char) (digval + '0');       /* a digit */
        } while (val > 0);

        /* We now have the digit of the number in the buffer, but in reverse
           order.  Thus we reverse them now. */

        *p-- = '\0';            /* terminate string; p points to last digit */

        do {
            temp = *p;
            *p = *firstdig;
            *firstdig = temp;   /* swap *p and *firstdig */
            --p;
            ++firstdig;         /* advance to next two digits */
        } while (firstdig < p); /* repeat until halfway */
}

/* Actual functions just call conversion helper with neg flag set correctly,
   and return pointer to buffer. */

char * _i64toaKAZE (
        long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE((unsigned long long)val, buf, radix, (radix == 10 && val < 0));
        return buf;
}

char * _ui64toaKAZE (
        unsigned long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE(val, buf, radix, 0);
        return buf;
}

char * _ui64toaKAZEzerocomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        do
                        { if (buf <= p)
                          { temp = *p;
                            buf[26-txpman] = temp; pxnman++;
                            p--;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          else
                          { buf[26-txpman] = (char) ('0'); pxnman++;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          txpman++;
                        } while (txpman <= 26);
        return buf;
}

char * _ui64toaKAZEcomma (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        while (buf <= p)
                        { temp = *p;
                          buf[26-txpman] = temp; pxnman++;
                          p--;
                          if (pxnman % 3 == 0 && buf <= p)
                          { txpman++;
                            buf[26-txpman] = (char) (',');
                          }
                          txpman++;
                        } 
        return buf+26-(txpman-1);
}

// Modified C Code by Kaze, original C Code by Kurt White.

// Can a knight placed on a chess board and jump to all 63 remaining squares
// only landing on each square once?
// Lets find out :)

#include <stdio.h>
#include <stdlib.h>

#include <time.h>

clock_t start,finish;
double duration;

/* List of valid moves a knight can make from any square */
int list[65][9] = { 0,0,0,0,0,0,0,0,0,
                                        11,18,0,0,0,0,0,0,0,    //1
                                        17,12,19,0,0,0,0,0,0,   //2
                                        9,13,18,20,0,0,0,0,0,   //3
                                        10,14,19,21,0,0,0,0,0,  //4
                                        15,11,20,22,0,0,0,0,0,  //5
                                        16,12,23,21,0,0,0,0,0,  //6
                                        24,13,22,0,0,0,0,0,0,   //7
                                        14,23,0,0,0,0,0,0,0,    //8
                                        3,26,19,0,0,0,0,0,0,    //9
                                        4,25,20,27,0,0,0,0,0,   //10
                                        1,5,17,26,21,28,0,0,0,  //11
                                        2,6,18,22,27,29,0,0,0,  //12
                                        7,3,23,19,28,30,0,0,0,  //13
                                        8,4,24,31,20,29,0,0,0,  //14
                                        5,32,21,30,0,0,0,0,0,   //15
                                        6,31,22,0,0,0,0,0,0,    //16
                                        2,11,34,27,0,0,0,0,0,   //17
                                        1,3,33,12,28,35,0,0,0,  //18
                                        2,9,4,25,13,34,29,36,0, //19
                                        3,5,10,14,26,30,35,37,0,//20
                                        4,6,15,11,31,27,36,38,0,//21
                                        7,16,5,32,12,39,28,37,0,//22
                                        8,6,40,13,29,38,0,0,0,  //23
                                        7,14,39,30,0,0,0,0,0,   //24
                                        10,42,19,35,0,0,0,0,0,  //25
                                        9,41,11,20,36,43,0,0,0, //26
                                        10,17,33,12,42,21,37,44,0, //27
                                        11,13,18,34,22,38,43,45,0, //28
                                        12,14,23,39,19,35,44,46,0, //29
                                        15,24,40,13,47,20,36,45,0, //30
                                        16,48,14,21,37,46,0,0,0,   //31
                                        15,47,22,38,0,0,0,0,0,  //32
                                        50,18,27,43,0,0,0,0,0,  //33
                                        49,17,51,19,28,44,0,0,0, //34
                                        25,41,50,52,18,20,29,45,0, //35
                                        26,42,51,53,19,21,30,46,0, //36
                                        31,47,52,54,20,22,27,43,0, //37
                                        32,48,55,53,23,21,28,44,0, //38
                                        56,24,54,22,29,45,0,0,0, //39
                                        55,23,30,46,0,0,0,0,0,  //40
                                        58,26,51,35,0,0,0,0,0,  //41
                                        57,25,59,52,27,36,0,0,0, //42
                                        49,58,33,60,26,53,28,37,0, //43
                                        59,61,50,54,34,27,29,38,0, //44
                                        60,62,55,39,51,28,30,35,0, //45
                                        63,56,61,40,52,31,29,36,0, //46
                                        64,62,32,53,30,37,0,0,0, //47
                                        63,31,54,38,0,0,0,0,0,  //48
                                        59,34,43,0,0,0,0,0,0,   //49
                                        33,60,35,44,0,0,0,0,0,  //50
                                        57,61,41,34,36,45,0,0,0, //51
                                        58,62,42,35,37,46,0,0,0, //52
                                        63,59,47,36,38,43,0,0,0, //53
                                        64,48,60,39,37,44,0,0,0, //54
                                        40,61,38,45,0,0,0,0,0,  //55
                                        62,39,46,0,0,0,0,0,0,   //56
                                        42,51,0,0,0,0,0,0,0,    //57
                                        41,52,43,0,0,0,0,0,0,   //58
                                        49,42,53,44,0,0,0,0,0,  //59
                                        50,54,43,45,0,0,0,0,0,  //60
                                        55,51,44,46,0,0,0,0,0,  //61
                                        56,47,52,45,0,0,0,0,0,  //62
                                        48,53,46,0,0,0,0,0,0,   //63
                                        47,54,0,0,0,0,0,0,0     //64
};

//     1  2  3  4  5  6  7  8
// 0: 02 03 04 04 04 04 03 02
// 1: 03 04 06 06 06 06 04 03
// 2: 04 06 08 08 08 08 06 04
// 3: 04 06 08 08 08 08 06 04
// 4: 04 06 08 08 08 08 06 04
// 5: 04 06 08 08 08 08 06 04
// 6: 03 04 06 06 06 06 04 03
// 7: 02 03 04 04 04 04 03 02

char *EightDigitBINlist[256] = {
"00000000\0",
"00000001\0",
"00000010\0",
"00000011\0",
"00000100\0",
"00000101\0",
"00000110\0",
"00000111\0",
"00001000\0",
"00001001\0",
"00001010\0",
"00001011\0",
"00001100\0",
"00001101\0",
"00001110\0",
"00001111\0",
"00010000\0",
"00010001\0",
"00010010\0",
"00010011\0",
"00010100\0",
"00010101\0",
"00010110\0",
"00010111\0",
"00011000\0",
"00011001\0",
"00011010\0",
"00011011\0",
"00011100\0",
"00011101\0",
"00011110\0",
"00011111\0",
"00100000\0",
"00100001\0",
"00100010\0",
"00100011\0",
"00100100\0",
"00100101\0",
"00100110\0",
"00100111\0",
"00101000\0",
"00101001\0",
"00101010\0",
"00101011\0",
"00101100\0",
"00101101\0",
"00101110\0",
"00101111\0",
"00110000\0",
"00110001\0",
"00110010\0",
"00110011\0",
"00110100\0",
"00110101\0",
"00110110\0",
"00110111\0",
"00111000\0",
"00111001\0",
"00111010\0",
"00111011\0",
"00111100\0",
"00111101\0",
"00111110\0",
"00111111\0",
"01000000\0",
"01000001\0",
"01000010\0",
"01000011\0",
"01000100\0",
"01000101\0",
"01000110\0",
"01000111\0",
"01001000\0",
"01001001\0",
"01001010\0",
"01001011\0",
"01001100\0",
"01001101\0",
"01001110\0",
"01001111\0",
"01010000\0",
"01010001\0",
"01010010\0",
"01010011\0",
"01010100\0",
"01010101\0",
"01010110\0",
"01010111\0",
"01011000\0",
"01011001\0",
"01011010\0",
"01011011\0",
"01011100\0",
"01011101\0",
"01011110\0",
"01011111\0",
"01100000\0",
"01100001\0",
"01100010\0",
"01100011\0",
"01100100\0",
"01100101\0",
"01100110\0",
"01100111\0",
"01101000\0",
"01101001\0",
"01101010\0",
"01101011\0",
"01101100\0",
"01101101\0",
"01101110\0",
"01101111\0",
"01110000\0",
"01110001\0",
"01110010\0",
"01110011\0",
"01110100\0",
"01110101\0",
"01110110\0",
"01110111\0",
"01111000\0",
"01111001\0",
"01111010\0",
"01111011\0",
"01111100\0",
"01111101\0",
"01111110\0",
"01111111\0",
"10000000\0",
"10000001\0",
"10000010\0",
"10000011\0",
"10000100\0",
"10000101\0",
"10000110\0",
"10000111\0",
"10001000\0",
"10001001\0",
"10001010\0",
"10001011\0",
"10001100\0",
"10001101\0",
"10001110\0",
"10001111\0",
"10010000\0",
"10010001\0",
"10010010\0",
"10010011\0",
"10010100\0",
"10010101\0",
"10010110\0",
"10010111\0",
"10011000\0",
"10011001\0",
"10011010\0",
"10011011\0",
"10011100\0",
"10011101\0",
"10011110\0",
"10011111\0",
"10100000\0",
"10100001\0",
"10100010\0",
"10100011\0",
"10100100\0",
"10100101\0",
"10100110\0",
"10100111\0",
"10101000\0",
"10101001\0",
"10101010\0",
"10101011\0",
"10101100\0",
"10101101\0",
"10101110\0",
"10101111\0",
"10110000\0",
"10110001\0",
"10110010\0",
"10110011\0",
"10110100\0",
"10110101\0",
"10110110\0",
"10110111\0",
"10111000\0",
"10111001\0",
"10111010\0",
"10111011\0",
"10111100\0",
"10111101\0",
"10111110\0",
"10111111\0",
"11000000\0",
"11000001\0",
"11000010\0",
"11000011\0",
"11000100\0",
"11000101\0",
"11000110\0",
"11000111\0",
"11001000\0",
"11001001\0",
"11001010\0",
"11001011\0",
"11001100\0",
"11001101\0",
"11001110\0",
"11001111\0",
"11010000\0",
"11010001\0",
"11010010\0",
"11010011\0",
"11010100\0",
"11010101\0",
"11010110\0",
"11010111\0",
"11011000\0",
"11011001\0",
"11011010\0",
"11011011\0",
"11011100\0",
"11011101\0",
"11011110\0",
"11011111\0",
"11100000\0",
"11100001\0",
"11100010\0",
"11100011\0",
"11100100\0",
"11100101\0",
"11100110\0",
"11100111\0",
"11101000\0",
"11101001\0",
"11101010\0",
"11101011\0",
"11101100\0",
"11101101\0",
"11101110\0",
"11101111\0",
"11110000\0",
"11110001\0",
"11110010\0",
"11110011\0",
"11110100\0",
"11110101\0",
"11110110\0",
"11110111\0",
"11111000\0",
"11111001\0",
"11111010\0",
"11111011\0",
"11111100\0",
"11111101\0",
"11111110\0",
"11111111\0"
};

void play( int );
void winner( void );

int board[65] = {0}; /* the Chess board   */
int moves[65];       /* list of moves     */
int k = 0;           /* move counter      */
  char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits2[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits3[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits4[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  char llTOaDigits5[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
  unsigned long long wincount = 0;
  unsigned long long Sequences = 0, Jumps = 0;
  int Verbose=0;
  #define KAZE_toupper(c) ( (((c) >= 'a') && ((c) <= 'z')) ? ((c) - 'a' + 'A') : (c) )
  #define KAZE_tolower(c) ( (((c) >= 'A') && ((c) <= 'Z')) ? ((c) - 'A' + 'a') : (c) )
  char Bunyo1, Bunyo2;
  //int KT;
  unsigned long long KT;

      char *pointerflush, *pointerflushUNALIGN;
      char *pointerflush2, *pointerflushUNALIGN2;
      char *pointerflush3, *pointerflushUNALIGN3;
      char *pointerflush4, *pointerflushUNALIGN4;
      char *pointerflush5, *pointerflushUNALIGN5;
      unsigned long memory_size;
      uint32_t Slot;
      char KTstring[128+1]; 
      char KTstringBRUTUS[128+1]; 
      uint32_t PseudoLinkedPointer=0;
      uint32_t MAXcollisionsAtSomeSlots=0;
      uint32_t MAXcollisionsAtSomeSlots2=0;
      uint32_t MAXcollisionsAtSomeSlots3=0;
      uint32_t MAXcollisionsAtSomeSlots4=0;
      uint32_t MAXcollisionsAtSomeSlots5=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM2=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM3=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM4=0;
      uint32_t MAXcollisionsAtSomeSlotsSUM5=0;
      uint32_t HASHfreeSLOTS;
      uint32_t HASHfreeSLOTS2;
      uint32_t HASHfreeSLOTS3;
      uint32_t HASHfreeSLOTS4;
      uint32_t HASHfreeSLOTS5;
      uint64_t KT_DumpCounter=0;

      time_t t1, t2;

int main(int argc, char *argv[])
{
printf("HASH_linearspeed_FURY: FNV1A_Yorikke vs CRC32_8slice, rev.3 written by Kaze.\n");
printf("Note1: The size-and-speed of L1/L2/L3 cache affects FNV1A_Yorikke and mostly FNV1A_Yoshimitsu a lot!\n");
printf("Note2: Executable was compiled with Microsoft 32bit VS2010 /Ox.\n");
printf("Note3: Results on my laptop:\n\n");

printf("OS: Windows XP 32bit\n");
printf("Motherboard Name: Toshiba Satellite L305  \n");
printf("CPU Type: Mobile DualCore Intel Core 2 Duo T7500  \n");
printf("CPU Alias: Merom  \n");
printf("CPU Clock: 2194.7 MHz (original: 2200 MHz)  \n");
printf("CPU Multiplier: 11x  \n");
printf("CPU FSB: 199.5 MHz (original: 200 MHz)  \n");
printf("Memory Bus: 332.5 MHz  \n");
printf("L1 Code Cache: 32 KB per core \n"); 
printf("L1 Data Cache: 32 KB per core  \n");
printf("L2 Cache: 4 MB (On-Die, ECC, ASC, Full-Speed)  \n");
printf("Memory Timings: 5-5-5-13 (CL-RCD-RP-RAS)  \n");
printf("Instruction Set: x86, x86-64, MMX, SSE, SSE2, SSE3, SSSE3  \n");
printf("Transistors: 291 million  \n");
printf("Process Technology: 8M, 65 nm, CMOS, Cu, Low-K Inter-Layer, 2nd Gen Strained Si  \n");
printf("Front Side Bus Properties:  \n");
printf("   Bus Type: Intel AGTL+  \n");
printf("   Bus Width: 64-bit  \n");
printf("   Real Clock: 200 MHz (QDR)  \n");
printf("   Effective Clock: 800 MHz  \n");
printf("   Bandwidth: 6400 MB/s  \n");
printf("Memory Bus Properties:  \n");
printf("   Bus Type: Dual DDR2 SDRAM \n"); 
printf("   Bus Width: 128-bit  \n");
printf("   DRAM:FSB Ratio: 10:6  \n");
printf("   Real Clock: 333 MHz (DDR)  \n");
printf("   Effective Clock: 667 MHz  \n");
printf("   Bandwidth: 10667 MB/s  \n");
printf("\nAnd the results:\n");
printf("\n");

printf("Hashing a 64MB block 1024 times i.e. 64GB ...\n");
printf("FNV1A_Yoshimitsu: (64MB block); 65536MB hashed in 16875 clocks or 3.884MB per clock\n");
printf("FNV1A_Yorikke: (64MB block); 65536MB hashed in 16782 clocks or 3.905MB per clock\n");
printf("CRC_SlicingBy8K2: (64MB block); 65536MB hashed in 66390 clocks or 0.987MB per clock\n");
printf("\n");
printf("Hashing a 10MB block 8*1024 times ...\n");
printf("FNV1A_Yoshimitsu: (10MB block); 81920MB hashed in 20610 clocks or 3.975MB per clock\n");
printf("FNV1A_Yorikke: (10MB block); 81920MB hashed in 20546 clocks or 3.987MB per clock\n");
printf("CRC_SlicingBy8K2: (10MB block); 81920MB hashed in 82938 clocks or 0.988MB per clock\n");
printf("\n");
printf("Hashing a 5MB block 8*1024 times ...\n");
printf("FNV1A_Yoshimitsu: (5MB block); 40960MB hashed in 9562 clocks or 4.284MB per clock\n");
printf("FNV1A_Yorikke: (5MB block); 40960MB hashed in 9531 clocks or 4.298MB per clock\n");
printf("CRC_SlicingBy8K2: (5MB block); 40960MB hashed in 41110 clocks or 0.996MB per clock\n");
printf("\n");
printf("Hashing a 2MB block 8*1024 times ...\n");
printf("FNV1A_Yoshimitsu: (2MB block); 16384MB hashed in 2578 clocks or 6.355MB per clock\n");
printf("FNV1A_Yorikke: (2MB block); 16384MB hashed in 2657 clocks or 6.166MB per clock\n");
printf("CRC_SlicingBy8K2: (2MB block); 16384MB hashed in 16156 clocks or 1.014MB per clock\n");
printf("\n");
printf("Hashing a 16KB block 1024*1024 times ...\n");
printf("FNV1A_Yoshimitsu: (16KB block); 16384MB hashed in 2437 clocks or 6.723MB per clock\n");
printf("FNV1A_Yorikke: (16KB block); 16384MB hashed in 2547 clocks or 6.433MB per clock\n");
printf("CRC_SlicingBy8K2: (16KB block); 16384MB hashed in 16078 clocks or 1.019MB per clock\n");
printf("\n");

memory_size = ( (1<<HashSizeInBits)*sizeof(uint32_t) ) + 1 + 64;
printf( "Allocating HASH memory %luMB ... ", (memory_size>>20) );
pointerflushUNALIGN = (char *)malloc( memory_size );
if( pointerflushUNALIGN == NULL )
{ puts( "\nKnight-tour_r8dump_Yorikke: Needed memory allocation denied!\n" ); return( 1 ); }
pointerflush = pointerflushUNALIGN + 64 - (((size_t)pointerflushUNALIGN) % 64);
//offset=64-int((long)data&63);
printf( "OK\n");
memset(pointerflush, 0, (1<<HashSizeInBits)*sizeof(uint32_t));


// ]

CRC_SlicingInitK2();

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

printf("\nHashing a %dMB block 1024 times i.e. %dGB ...\n", (1<<HashSizeInBits)>>20, (1<<HashSizeInBits)>>20);

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimitsu(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time FNV1A_Yoshimitsu: %f clocks\n", duration);
//printf("\nTime FNV1A_Yoshimitsu: %d clocks\n", (int) duration);
//printf("Speed FNV1A_Yoshimitsu: %.3fMB per clock\n", (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
printf("FNV1A_Yoshimitsu: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time FNV1A_Yorikke: %f clocks\n", duration);
//printf("\nTime FNV1A_Yorikke: %d clocks\n", (int) duration);
//printf("Speed FNV1A_Yorikke: %.3fMB per clock\n", (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
printf("FNV1A_Yorikke: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, (1<<HashSizeInBits)) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time CRC_SlicingBy8K2: %f clocks\n", duration);
//printf("\nTime CRC_SlicingBy8K2: %d clocks\n", (int) duration);
//printf("Speed CRC_SlicingBy8K2: %.3fMB per clock\n", (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));
printf("CRC_SlicingBy8K2: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (1<<HashSizeInBits)>>20, 1024*( (1<<HashSizeInBits)>>20 ), (int) duration, (float)1024*( (1<<HashSizeInBits)>>20 )/ ((int) duration));

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

printf("\nHashing a %dMB block 8*1024 times ...\n", (10*1024*1024)>>20);

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimitsu(pointerflush, 10*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time FNV1A_Yoshimitsu: %f clocks\n", duration);
//printf("\nTime FNV1A_Yoshimitsu: %d clocks\n", (int) duration);
//printf("Speed FNV1A_Yoshimitsu: %.3fMB per clock\n", (float)8*1024*( (10*1024*1024)>>20 )/ ((int) duration));
printf("FNV1A_Yoshimitsu: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (10*1024*1024)>>20, 8*1024*( (10*1024*1024)>>20 ), (int) duration, (float)8*1024*( (10*1024*1024)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, 10*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time FNV1A_Yorikke: %f clocks\n", duration);
//printf("\nTime FNV1A_Yorikke: %d clocks\n", (int) duration);
//printf("Speed FNV1A_Yorikke: %.3fMB per clock\n", (float)8*1024*( (10*1024*1024)>>20 )/ ((int) duration));
printf("FNV1A_Yorikke: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (10*1024*1024)>>20, 8*1024*( (10*1024*1024)>>20 ), (int) duration, (float)8*1024*( (10*1024*1024)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, 10*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time CRC_SlicingBy8K2: %f clocks\n", duration);
//printf("\nTime CRC_SlicingBy8K2: %d clocks\n", (int) duration);
//printf("Speed CRC_SlicingBy8K2: %.3fMB per clock\n", (float)8*1024*( (10*1024*1024)>>20 )/ ((int) duration));
printf("CRC_SlicingBy8K2: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (10*1024*1024)>>20, 8*1024*( (10*1024*1024)>>20 ), (int) duration, (float)8*1024*( (10*1024*1024)>>20 )/ ((int) duration));

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

printf("\nHashing a %dMB block 8*1024 times ...\n", (5*1024*1024)>>20);

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimitsu(pointerflush, 5*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time FNV1A_Yoshimitsu: %f clocks\n", duration);
//printf("\nTime FNV1A_Yoshimitsu: %d clocks\n", (int) duration);
//printf("Speed FNV1A_Yoshimitsu: %.3fMB per clock\n", (float)8*1024*( (5*1024*1024)>>20 )/ ((int) duration));
printf("FNV1A_Yoshimitsu: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (5*1024*1024)>>20, 8*1024*( (5*1024*1024)>>20 ), (int) duration, (float)8*1024*( (5*1024*1024)>>20 )/ ((int) duration));


(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, 5*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time FNV1A_Yorikke: %f clocks\n", duration);
//printf("\nTime FNV1A_Yorikke: %d clocks\n", (int) duration);
//printf("Speed FNV1A_Yorikke: %.3fMB per clock\n", (float)8*1024*( (5*1024*1024)>>20 )/ ((int) duration));
printf("FNV1A_Yorikke: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (5*1024*1024)>>20, 8*1024*( (5*1024*1024)>>20 ), (int) duration, (float)8*1024*( (5*1024*1024)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, 5*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time CRC_SlicingBy8K2: %f clocks\n", duration);
//printf("\nTime CRC_SlicingBy8K2: %d clocks\n", (int) duration);
//printf("Speed CRC_SlicingBy8K2: %.3fMB per clock\n", (float)8*1024*( (5*1024*1024)>>20 )/ ((int) duration));
printf("CRC_SlicingBy8K2: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (5*1024*1024)>>20, 8*1024*( (5*1024*1024)>>20 ), (int) duration, (float)8*1024*( (5*1024*1024)>>20 )/ ((int) duration));

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

printf("\nHashing a %dMB block 8*1024 times ...\n", (2*1024*1024)>>20);

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimitsu(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time FNV1A_Yoshimitsu: %f clocks\n", duration);
//printf("\nTime FNV1A_Yoshimitsu: %d clocks\n", (int) duration);
//printf("Speed FNV1A_Yoshimitsu: %.3fMB per clock\n", (float)8*1024*( (2*1024*1024)>>20 )/ ((int) duration));
printf("FNV1A_Yoshimitsu: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 8*1024*( (2*1024*1024)>>20 ), (int) duration, (float)8*1024*( (2*1024*1024)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time FNV1A_Yorikke: %f clocks\n", duration);
//printf("\nTime FNV1A_Yorikke: %d clocks\n", (int) duration);
//printf("Speed FNV1A_Yorikke: %.3fMB per clock\n", (float)8*1024*( (2*1024*1024)>>20 )/ ((int) duration));
printf("FNV1A_Yorikke: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 8*1024*( (2*1024*1024)>>20 ), (int) duration, (float)8*1024*( (2*1024*1024)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 8*1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, 2*1024*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

//printf("Time CRC_SlicingBy8K2: %f clocks\n", duration);
//printf("\nTime CRC_SlicingBy8K2: %d clocks\n", (int) duration);
//printf("Speed CRC_SlicingBy8K2: %.3fMB per clock\n", (float)8*1024*( (2*1024*1024)>>20 )/ ((int) duration));
printf("CRC_SlicingBy8K2: (%dMB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (2*1024*1024)>>20, 8*1024*( (2*1024*1024)>>20 ), (int) duration, (float)8*1024*( (2*1024*1024)>>20 )/ ((int) duration));

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

printf("\nHashing a %dKB block 1024*1024 times ...\n", (16*1024)>>10);

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 1024*1024; KT++) {
	Slot = ( FNV1A_Hash_Yoshimitsu(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

printf("FNV1A_Yoshimitsu: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 1024*( (1024*16*1024)>>20 ), (int) duration, (float)1024*( (1024*16*1024)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 1024*1024; KT++) {
	Slot = ( FNV1A_Hash_Yorikke(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

printf("FNV1A_Yorikke: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 1024*( (1024*16*1024)>>20 ), (int) duration, (float)1024*( (1024*16*1024)>>20 )/ ((int) duration));

(void) time(&t1);
start = clock();

	for (KT = 0; KT < 1024*1024; KT++) {
	Slot = ( CRC_SlicingBy8K2(pointerflush, 16*1024) & ((1<<HashSizeInBits)-1) )<<2;
	}
finish = clock();
duration = (double) (finish - start); // / CLOCKS_PER_SEC;
(void) time(&t2);
if (t2 <= t1) {t2 = t1; t2++;}

printf("CRC_SlicingBy8K2: (%dKB block); %dMB hashed in %d clocks or %.3fMB per clock\n", (16*1024)>>10, 1024*( (1024*16*1024)>>20 ), (int) duration, (float)1024*( (1024*16*1024)>>20 )/ ((int) duration));

// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	exit(1);

	//for (KT = 0; KT < 256; KT++) {
	//printf("%s\n", _ui64toaKAZEzerocomma(KT, llTOaDigits, 2)+(26-10) );
	//}
	//exit(1);

                        start = clock();

   //printf("\nCode (00508-00270+1=665bytes long compiled with Microsoft V16 32bit /Ox) is being executed, recursive exhaustive depth-first searching ...\n");
   if (Verbose==1) printf("|Sequences(only failures):  |Jumps i.e. knight's moves: |Elapsed seconds:\n");

   // 1 2 3 ... 8   a8 b8 ... h8
   // 9 ...         a7 ...
   // ...      64   ...       h1
   play( (Bunyo2-'A') + (8-(Bunyo1-'1'+1))*8 + 1 );
   printf("\n");
   printf("Total recursions(jumps i.e. knight's moves): %I64d\n", Jumps);
   printf("Total solutions(tours): %I64d\n", wincount);
}

//char BarIndicator[65]; 
unsigned long nTrys_High = 0, nTrys_Low = 0;

void play( int square )
{
  int i;

  Jumps++;
  // nTrys_Low++; if (nTrys_Low == 0) nTrys_High++;

   board[square] = 1;
   moves[k++] = square;

             //for (i=1; i<65;i++) if (i-k>0) BarIndicator[i]=' '; else BarIndicator[i]='#';
             //printf(" [%s]\n", &BarIndicator[1]);

if ((++nTrys_Low & 0x0FFFFFFF) == 0x0FFFFFFF) { // 4x 16 millions
                        finish = clock();
                        duration = (double) (finish - start) / CLOCKS_PER_SEC;
             if (Verbose==1) printf("|%s |%s |%.2f \r", _ui64toaKAZEzerocomma(Sequences, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma(Jumps, llTOaDigits2, 10)+(26-26), duration);
                               }

   if (k == 64)
   {
             wincount++;
                        finish = clock();
                        duration = (double) (finish - start) / CLOCKS_PER_SEC;
             if (Verbose==1) {
                 printf("|%s |%s |%.2f \r", _ui64toaKAZEzerocomma(Sequences, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma(Jumps, llTOaDigits2, 10)+(26-26), duration);
                 winner();
             } else if (Verbose==3) {
                 winner();
                 if ( wincount == KT ) {
                 //printf("|%s |%s |%.2f \r", _ui64toaKAZEzerocomma(Sequences, llTOaDigits, 10)+(26-26), _ui64toaKAZEzerocomma(Jumps, llTOaDigits2, 10)+(26-26), duration);
                 exit(1);
                 }
             } else if (Verbose==2) {
                 winner();
             } else {
             }

      board[square] = 0; k--; return;
   }
   for (i = 0; list[square][i] != 0; i++)
   {
      if (board[list[square][i]] == 0)
         play(list[square][i]);
      else
         if (list[square][i+1] == 0)
         {
         Sequences++;
         if (Verbose==2) winner();
         }
   }
   board[square] = 0; k--; return;


free(pointerflushUNALIGN);

}

void winner( void )
{
   int i;
   int BrutusLet;
   int BrutusPos;
   int BrutusBIN;

     for (i = 0; i < k; i++) {
         //printf( "%c%d", 'A'+( (moves[i]-1)%8+1 )-1, 9-( (moves[i]-1)/8+1 ) );
         KTstring[i*2] = 'A'+( (moves[i]-1)%8+1 )-1;
         KTstring[i*2+1] = '0'+9-( (moves[i]-1)/8+1 );
     }

     //printf("\n");

	KTstring[128] = 0;
	KTstringBRUTUS[128] = 0;
	//printf("%s\n",KTstring);
//	KT_DumpCounter++;

   if (Verbose==1) printf("\n|Sequences(only failures):  |Jumps i.e. knight's moves: |Elapsed seconds:\n");


if (PrintTheFirstKTvariants == 0) {
	printf("The first KT:\n%s\ngives following 64 UNIQUE derivatives:\n",KTstring);
}

	for (BrutusPos = 0; BrutusPos < 64; BrutusPos++) {
/*
	for (BrutusLet = 0; BrutusLet < 32; BrutusLet++) {
	for (BrutusPos = 0; BrutusPos < 64; BrutusPos++) {
		memcpy( KTstringBRUTUS, KTstring, 128 );
		KTstringBRUTUS[BrutusPos*2] = KTstring[BrutusPos*2] - (BrutusLet+1);
		KT_DumpCounter++;
		if (PrintTheFirstKTvariants == 0) {
			printf("%s\n",KTstringBRUTUS);
		}
*/
		memcpy( KTstringBRUTUS, KTstring, 128 );
		KTstringBRUTUS[BrutusPos*2] = KAZE_tolower(KTstring[BrutusPos*2]);
		KT_DumpCounter++;
		if (PrintTheFirstKTvariants == 0) {
			printf("%s\n",KTstringBRUTUS);
		}

	Slot = ( FNV1A_Hash_Yorikke(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8K1(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush2+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush2+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8K2(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush3+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush3+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8C1(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush4+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush4+Slot, &PseudoLinkedPointer, 4 );

	Slot = ( CRC_SlicingBy8C2(KTstringBRUTUS, 128) & ((1<<HashSizeInBits)-1) )<<2;

	memcpy( &PseudoLinkedPointer, pointerflush5+Slot, 4 );
	PseudoLinkedPointer++;
	memcpy( pointerflush5+Slot, &PseudoLinkedPointer, 4 );

	HASHfreeSLOTS = 0;
	HASHfreeSLOTS2 = 0;
	HASHfreeSLOTS3 = 0;
	HASHfreeSLOTS4 = 0;
	HASHfreeSLOTS5 = 0;
	MAXcollisionsAtSomeSlotsSUM = 0;
	MAXcollisionsAtSomeSlotsSUM2 = 0;
	MAXcollisionsAtSomeSlotsSUM3 = 0;
	MAXcollisionsAtSomeSlotsSUM4 = 0;
	MAXcollisionsAtSomeSlotsSUM5 = 0;
	if ( (KT_DumpCounter & ReportAtEvery) == ReportAtEvery ) {
		for (i = 0; i < 1<<HashSizeInBits; i++) {
			memcpy( &PseudoLinkedPointer, pointerflush+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots ) MAXcollisionsAtSomeSlots = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush2+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS2++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots2 ) MAXcollisionsAtSomeSlots2 = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush3+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS3++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots3 ) MAXcollisionsAtSomeSlots3 = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush4+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS4++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots4 ) MAXcollisionsAtSomeSlots4 = PseudoLinkedPointer;
			memcpy( &PseudoLinkedPointer, pointerflush5+((i)<<2), 4 );
			if (PseudoLinkedPointer == 0 ) HASHfreeSLOTS5++;
			if (PseudoLinkedPointer > MAXcollisionsAtSomeSlots5 ) MAXcollisionsAtSomeSlots5 = PseudoLinkedPointer;
		}
		for (i = 0; i < 1<<HashSizeInBits; i++) {
			memcpy( &PseudoLinkedPointer, pointerflush+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots ) MAXcollisionsAtSomeSlotsSUM++;
			memcpy( &PseudoLinkedPointer, pointerflush2+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots2 ) MAXcollisionsAtSomeSlotsSUM2++;
			memcpy( &PseudoLinkedPointer, pointerflush3+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots3 ) MAXcollisionsAtSomeSlotsSUM3++;
			memcpy( &PseudoLinkedPointer, pointerflush4+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots4 ) MAXcollisionsAtSomeSlotsSUM4++;
			memcpy( &PseudoLinkedPointer, pointerflush5+((i)<<2), 4 );
			if (PseudoLinkedPointer == MAXcollisionsAtSomeSlots5 ) MAXcollisionsAtSomeSlotsSUM5++;
		}
	printf("FNV1A_Yorikke : KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );

	printf("CRC32K1_8slice: KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM2, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots2, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS2, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS2)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
	printf("CRC32K2_8slice: KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM3, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots3, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS3, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS3)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );

	printf("CRC32C1_8slice: KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM4, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots4, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS4, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS4)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
	printf("CRC32C2_8slice: KT_derivatives = %s; %s x MAXcollisionsAtSomeSlots = %s; HASHfreeSLOTS = %s; HashUtilization = %s%%\n", _ui64toaKAZEzerocomma(KT_DumpCounter, llTOaDigits, 10)+(26-18), _ui64toaKAZEzerocomma( MAXcollisionsAtSomeSlotsSUM5, llTOaDigits5, 10)+(26-11), _ui64toaKAZEzerocomma(MAXcollisionsAtSomeSlots5, llTOaDigits2, 10)+(26-7), _ui64toaKAZEzerocomma(HASHfreeSLOTS5, llTOaDigits3, 10)+(26-13), _ui64toaKAZEzerocomma(( ((1<<HashSizeInBits)-HASHfreeSLOTS5)*(unsigned long long)100 ) / (1<<HashSizeInBits), llTOaDigits4, 10)+(26-3) );
	}

/*
	} //for (BrutusPos...
	} //for (BrutusLet...
*/
	} //for (BrutusPos...

	PrintTheFirstKTvariants = 1;
}


/*

*/